SetMultimap
Date: 2016-05-24

com.google.common.collect

## Interface SetMultimap<K,V>

- All Superinterfaces:
    Multimap<K,V>
  All Known Subinterfaces:
    SortedSetMultimap<K,V>
  All Known Implementing Classes:
    ForwardingSetMultimap, ForwardingSortedSetMultimap, HashMultimap, ImmutableSetMultimap, LinkedHashMultimap, TreeMultimap

      @GwtCompatible
      public interface SetMultimap<K,V>
      extends Multimap<K,V>

  A `Multimap` that cannot hold duplicate key-value pairs. Adding a key-value pair that's already in the multimap has no effect. See the `Multimap` documentation for information common to all multimaps.

  The `get(K)`, `removeAll(java.lang.Object)`, and `replaceValues(K, java.lang.Iterable<? extends V>)` methods each return a `Set` of values, while `entries()` returns a `Set` of map entries. Though the method signature doesn't say so explicitly, the map returned by `asMap()` has `Set` values.

  If the values corresponding to a single key should be ordered according to a `Comparator` (or the natural order), see the `SortedSetMultimap` subinterface.

  Since the value collections are sets, the behavior of a `SetMultimap` is not specified if key or value objects already present in the multimap change in a manner that affects `equals` comparisons. Use caution if mutable objects are used as keys or values in a `SetMultimap`.

  See the Guava User Guide article on `Multimap`.

  Since:
    2.0

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Map<K,java.util.Collection<V>>` | `asMap()` Returns a view of this multimap as a `Map` from each distinct key to the nonempty collection of that key's associated values.
    `java.util.Set<java.util.Map.Entry<K,V>>` | `entries()` Returns a view collection of all key-value pairs contained in this multimap, as `Map.Entry` instances.
    `boolean` | `equals(java.lang.Object obj)` Compares the specified object to this multimap for equality.
    `java.util.Set<V>` | `get(K key)` Returns a view collection of the values associated with `key` in this multimap, if any.
    `java.util.Set<V>` | `removeAll(java.lang.Object key)` Removes all values associated with the key `key`.
    `java.util.Set<V>` | `replaceValues(K key, java.lang.Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.

    - ### Methods inherited from interface com.google.common.collect.Multimap

      `clear, containsEntry, containsKey, containsValue, hashCode, isEmpty, keys, keySet, put, putAll, putAll, remove, size, values`

- - ### Method Detail

    - #### get

          java.util.Set<V> get(@Nullable
                             K key)

      Returns a view collection of the values associated with `key` in this multimap, if any. Note that when `containsKey(key)` is false, this returns an empty collection, not `null`.

      Changes to the returned collection will update the underlying multimap, and vice versa.

      Because a `SetMultimap` has unique values for a given key, this method returns a `Set`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `get` in interface `Multimap<K,V>`

    - #### removeAll

          java.util.Set<V> removeAll(@Nullable
                                   java.lang.Object key)

      Removes all values associated with the key `key`.

      Once this method returns, `key` will not be mapped to any values, so it will not appear in `Multimap.keySet()`, `Multimap.asMap()`, or any other views.

      Because a `SetMultimap` has unique values for a given key, this method returns a `Set`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `removeAll` in interface `Multimap<K,V>`
      Returns:
        the values that were removed (possibly empty). The returned collection may be modifiable, but updating it will have no effect on the multimap.

    - #### replaceValues

          java.util.Set<V> replaceValues(K key,
                                       java.lang.Iterable<? extends V> values)

      Stores a collection of values with the same key, replacing any existing values for that key.

      If `values` is empty, this is equivalent to `removeAll(key)`.

      Because a `SetMultimap` has unique values for a given key, this method returns a `Set`, instead of the `Collection` specified in the `Multimap` interface.

      Any duplicates in `values` will be stored in the multimap once.

      Specified by:
        `replaceValues` in interface `Multimap<K,V>`
      Returns:
        the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.

    - #### entries

          java.util.Set<java.util.Map.Entry<K,V>> entries()

      Returns a view collection of all key-value pairs contained in this multimap, as `Map.Entry` instances.

      Changes to the returned collection or the entries it contains will update the underlying multimap, and vice versa. However, adding to the returned collection is not possible.

      Because a `SetMultimap` has unique values for a given key, this method returns a `Set`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `entries` in interface `Multimap<K,V>`

    - #### asMap

          java.util.Map<K,java.util.Collection<V>> asMap()

      Returns a view of this multimap as a `Map` from each distinct key to the nonempty collection of that key's associated values. Note that `this.asMap().get(k)` is equivalent to `this.get(k)` only when `k` is a key contained in the multimap; otherwise it returns `null` as opposed to an empty collection.

      Changes to the returned map or the collections that serve as its values will update the underlying multimap, and vice versa. The map does not support `put` or `putAll`, nor do its entries support `setValue`.

      Note: The returned map's values are guaranteed to be of type `Set`. To obtain this map with the more specific generic type `Map<K, Set<V>>`, call `Multimaps.asMap(SetMultimap)` instead.

      Specified by:
        `asMap` in interface `Multimap<K,V>`

    - #### equals

          boolean equals(@Nullable
                       java.lang.Object obj)

      Compares the specified object to this multimap for equality.

      Two `SetMultimap` instances are equal if, for each key, they contain the same values. Equality does not depend on the ordering of keys or values.

      An empty `SetMultimap` is equal to any other empty `Multimap`, including an empty `ListMultimap`.

      Specified by:
        `equals` in interface `Multimap<K,V>`
      Overrides:
        `equals` in class `java.lang.Object`